[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]
[Qemu-devel] [PATCH v10 1/6] block: round up file size to nearest sector
From: |
Hu Tao |
Subject: |
[Qemu-devel] [PATCH v10 1/6] block: round up file size to nearest sector |
Date: |
Thu, 12 Jun 2014 11:54:22 +0800 |
Signed-off-by: Hu Tao <address@hidden>
---
block/qcow2.c | 2 +-
block/raw-posix.c | 2 +-
block/raw-win32.c | 2 +-
tests/qemu-iotests/093 | 64 ++++++++++++++++++++++++++++++++++++++++++++++
tests/qemu-iotests/093.out | 14 ++++++++++
tests/qemu-iotests/group | 1 +
6 files changed, 82 insertions(+), 3 deletions(-)
create mode 100755 tests/qemu-iotests/093
create mode 100644 tests/qemu-iotests/093.out
diff --git a/block/qcow2.c b/block/qcow2.c
index a54d2ba..75b28cd 100644
--- a/block/qcow2.c
+++ b/block/qcow2.c
@@ -1778,7 +1778,7 @@ static int qcow2_create(const char *filename,
QEMUOptionParameter *options,
/* Read out options */
while (options && options->name) {
if (!strcmp(options->name, BLOCK_OPT_SIZE)) {
- sectors = options->value.n / 512;
+ sectors = DIV_ROUND_UP(options->value.n, BDRV_SECTOR_SIZE);
} else if (!strcmp(options->name, BLOCK_OPT_BACKING_FILE)) {
backing_file = options->value.s;
} else if (!strcmp(options->name, BLOCK_OPT_BACKING_FMT)) {
diff --git a/block/raw-posix.c b/block/raw-posix.c
index c2b30be..c5b81e1 100644
--- a/block/raw-posix.c
+++ b/block/raw-posix.c
@@ -1285,7 +1285,7 @@ static int raw_create(const char *filename,
QEMUOptionParameter *options,
/* Read out options */
while (options && options->name) {
if (!strcmp(options->name, BLOCK_OPT_SIZE)) {
- total_size = options->value.n / BDRV_SECTOR_SIZE;
+ total_size = DIV_ROUND_UP(options->value.n, BDRV_SECTOR_SIZE);
}
options++;
}
diff --git a/block/raw-win32.c b/block/raw-win32.c
index 324e818..8f83fab 100644
--- a/block/raw-win32.c
+++ b/block/raw-win32.c
@@ -514,7 +514,7 @@ static int raw_create(const char *filename,
QEMUOptionParameter *options,
/* Read out options */
while (options && options->name) {
if (!strcmp(options->name, BLOCK_OPT_SIZE)) {
- total_size = options->value.n / 512;
+ total_size = DIV_ROUND_UP(options->value.n, BDRV_SECTOR_SIZE);
}
options++;
}
diff --git a/tests/qemu-iotests/093 b/tests/qemu-iotests/093
new file mode 100755
index 0000000..02316d1
--- /dev/null
+++ b/tests/qemu-iotests/093
@@ -0,0 +1,64 @@
+#!/bin/bash
+#
+# Test qcow2 preallocation with different cluster_sizes
+#
+# Copyright (C) 2014 Fujitsu.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+# creator
address@hidden
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+
+_cleanup()
+{
+ _cleanup_test_img
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+_supported_fmt qcow2
+_supported_proto file
+_supported_os Linux
+
+function test_qemu_img()
+{
+ echo qemu-img "$@" | _filter_testdir
+ $QEMU_IMG "$@" 2>&1 | _filter_testdir
+ echo
+}
+
+echo "=== Check qemu-img info output ==="
+echo
+image_sizes="1024 1234"
+
+for s in $image_sizes; do
+ _make_test_img $s
+ _img_info
+done
+
+# success, all done
+echo "*** done"
+rm -f $seq.full
+status=0
diff --git a/tests/qemu-iotests/093.out b/tests/qemu-iotests/093.out
new file mode 100644
index 0000000..766b512
--- /dev/null
+++ b/tests/qemu-iotests/093.out
@@ -0,0 +1,14 @@
+QA output created by 093
+=== Check qemu-img info output ===
+
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=1024
+image: TEST_DIR/t.IMGFMT
+file format: IMGFMT
+virtual size: 1.0K (1024 bytes)
+cluster_size: 65536
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=1234
+image: TEST_DIR/t.IMGFMT
+file format: IMGFMT
+virtual size: 1.5K (1536 bytes)
+cluster_size: 65536
+***done
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
index 0f07440..304b596 100644
--- a/tests/qemu-iotests/group
+++ b/tests/qemu-iotests/group
@@ -99,3 +99,4 @@
090 rw auto quick
091 rw auto
092 rw auto quick
+093 rw auto
--
1.9.3
- [Qemu-devel] [PATCH v10 0/6] qemu-img: add preallocation=full, Hu Tao, 2014/06/11
- [Qemu-devel] [PATCH v10 1/6] block: round up file size to nearest sector,
Hu Tao <=
- [Qemu-devel] [PATCH v10 4/6] qapi: introduce PreallocMode and a new PreallocMode full., Hu Tao, 2014/06/11
- [Qemu-devel] [PATCH v10 3/6] rename parse_enum_option to qapi_enum_parse and make it public, Hu Tao, 2014/06/11
- [Qemu-devel] [PATCH v10 2/6] raw, qcow2: don't convert file size to sector size, Hu Tao, 2014/06/11
- [Qemu-devel] [PATCH v10 5/6] raw-posix: Add full image preallocation option, Hu Tao, 2014/06/11